/*
 * Created on 8 mars 2005
 *
 */
package istia.st.articles.web.struts;

import istia.st.articles.dao.Article;
import istia.st.articles.domain.Achat;
import istia.st.articles.domain.Panier;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author serge
 *  
 */
public class AchatArticleAction extends Action {

  /**
   * achat d'un article - s'appuie sur la couche [domain]
   * 
   * @param mapping :
   *          configuration de l'action dans struts-config.xml
   * @param form :
   *          le formulaire pass  l'action - ici aucun
   * @param request :
   *          la requte HTTP du client
   * @param response :
   *          la rponse HTTP au client
   */
  public ActionForward execute(ActionMapping mapping, ActionForm form,
      HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
    // la servlet de contrle
    MainServlet mainServlet = (MainServlet) this.getServlet();
    // erreurs d'initialisation ?
    ArrayList erreursInit = mainServlet.getErreurs();
    if (erreursInit.size() != 0) {
      // on affiche la page des erreurs
      request.setAttribute("erreurs", erreursInit);
      request.setAttribute("actions", new Hashtable[] {});
      return mapping.findForward("afficherErreurs");
    }
    // la liste des erreurs sur cette action
    ArrayList erreurs = new ArrayList();
    // on rcupre la quantit achete
    int qt = 0;
    try {
      qt = Integer.parseInt(request.getParameter("qte"));
      if (qt <= 0)
        throw new NumberFormatException();
    } catch (NumberFormatException ex) {
      // qt errone
      request.setAttribute("msg", "Quantit incorrecte");
      request.setAttribute("qte", request.getParameter("qte"));
      request.setAttribute("actions", new Hashtable[] { mainServlet
          .getHActionListe() });
      return mapping.findForward("afficherInfosArticle");
    }
    // on rcupre la session du client
    HttpSession session = request.getSession();
    // on rcupre l'article mis en session
    Article article = (Article) session.getAttribute("article");
    // session expire ?
    if(article==null){
      // on affiche la page des erreurs
      erreurs.add("Votre session a expir");
      request.setAttribute("erreurs", erreurs);
      request.setAttribute("actions", new Hashtable[] { mainServlet
          .getHActionListe() });
      return mapping.findForward("afficherErreurs");      
    }
    // on cre le nouvel achat
    Achat achat = new Achat(article, qt);
    // on ajoute l'achat au panier du client
    Panier panier = (Panier) session.getAttribute("panier");
    if (panier == null) {
      panier = new Panier();
      session.setAttribute("panier", panier);
    }
    panier.ajouter(achat);
    // on revient  la liste des articles
    return mapping.findForward("afficherListeArticles");
  }
}