/*
 * Created on 8 mars 2005
 *
 */
package istia.st.articles.web.struts;

import istia.st.articles.dao.Article;
import istia.st.articles.domain.IArticlesDomain;
import istia.st.articles.exception.UncheckedAccessArticlesException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author serge
 *  
 */
public class InfosArticleAction extends Action {

  /**
   * affichage des informations lies  un article donn - s'appuie sur la couche [domain]
   * 
   * @param mapping :
   *          configuration de l'action dans struts-config.xml
   * @param form :
   *          le formulaire pass  l'action - ici aucun
   * @param request :
   *          la requte HTTP du client
   * @param response :
   *          la rponse HTTP au client
   */
  public ActionForward execute(ActionMapping mapping, ActionForm form,
      HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
    // la servlet de contrle
    MainServlet mainServlet = (MainServlet) this.getServlet();
    // erreurs d'initialisation ?
    ArrayList erreursInit = mainServlet.getErreurs();
    if (erreursInit.size() != 0) {
      // on affiche la page des erreurs
      request.setAttribute("erreurs", erreursInit);
      request.setAttribute("actions", new Hashtable[] {});
      return mapping.findForward("afficherErreurs");
    }
    // l'objet d'accs au domaine
    IArticlesDomain articlesDomain = mainServlet.getArticlesDomain();
    // la liste des erreurs
    ArrayList erreurs = new ArrayList();
    // on rcupre l'id demand
    String strId = request.getParameter("id");
    // qq chose ?
    if (strId == null) {
      // pas normal
      erreurs.add("action incorrecte([infos,id=null]");
      request.setAttribute("erreurs", erreurs);
      request.setAttribute("actions", new Hashtable[] { mainServlet
          .getHActionListe() });
      return mapping.findForward("afficherErreurs");
    }
    // on transforme strId en entier
    int id = 0;
    try {
      id = Integer.parseInt(strId);
    } catch (Exception ex) {
      // pas normal
      erreurs.add("action incorrecte([infos,id=" + strId + "]");
      request.setAttribute("erreurs", erreurs);
      request.setAttribute("actions", new Hashtable[] { mainServlet
          .getHActionListe() });
      return mapping.findForward("afficherErreurs");
    }
    // on demande l'article de cl id
    Article article = null;
    try {
      article = articlesDomain.getArticleById(id);
    } catch (UncheckedAccessArticlesException ex) {
      // pas normal
      erreurs.add("Erreur d'accs aux donnes [" + ex.toString() + "]");
      request.setAttribute("erreurs", erreurs);
      request.setAttribute("actions", new Hashtable[] { mainServlet
          .getHActionListe() });
      return mapping.findForward("afficherErreurs");
    }
    if (article == null) {
      // pas normal
      erreurs.add("Article de cl [" + id + "] inexistant");
      request.setAttribute("erreurs", erreurs);
      request.setAttribute("actions", new Hashtable[] { mainServlet
          .getHActionListe() });
      return mapping.findForward("afficherErreurs");
    }
    // on met l'article dans la session
    request.getSession().setAttribute("article", article);
    // on affiche la page d'infos
    request.setAttribute("actions", new Hashtable[] { mainServlet
        .getHActionListe() });
    return mapping.findForward("afficherInfosArticle");
  }
}