/*
 * Created on 8 mars 2005
 *
 */
package istia.st.articles.web.struts;

import istia.st.articles.domain.IArticlesDomain;

import java.util.ArrayList;
import java.util.Hashtable;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;

import org.apache.struts.action.ActionServlet;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;

/**
 * @author ST - ISTIA
 *  
 */
public class MainServlet extends ActionServlet {
  // champs privs
  private ArrayList erreurs = new ArrayList();
  private IArticlesDomain articlesDomain = null;
  private final String SPRING_CONFIG_FILENAME = "springConfigFileName";
  private final String[] parameters = { SPRING_CONFIG_FILENAME };
  private ServletConfig config;
  private final String ACTION_LISTE = "liste.do";
  private final String ACTION_PANIER = "panier.do";
  private final String ACTION_ACHAT = "achat.do";
  private final String ACTION_INFOS = "infos.do";
  private final String ACTION_RETIRER_ACHAT = "retirerachat.do";
  private final String ACTION_VALIDATION_PANIER = "validerpanier.do";
  private String urlActionListe;
  private final String lienActionListe = "Liste des articles";
  private String urlActionPanier;
  private final String lienActionPanier = "Voir le panier";
  private String urlActionValidationPanier;
  private final String lienActionValidationPanier = "Valider le panier";
  private Hashtable hActionListe = new Hashtable(2);
  private Hashtable hActionPanier = new Hashtable(2);
  private Hashtable hActionValidationPanier = new Hashtable(2);

  /**
   * @return Returns the articlesDomain.
   */
  public IArticlesDomain getArticlesDomain() {
    return articlesDomain;
  }
  /**
   * @param articlesDomain The articlesDomain to set.
   */
  public void setArticlesDomain(IArticlesDomain articlesDomain) {
    this.articlesDomain = articlesDomain;
  }
  /**
   * @return Returns the erreurs.
   */
  public ArrayList getErreurs() {
    return erreurs;
  }
  /**
   * @param erreurs The erreurs to set.
   */
  public void setErreurs(ArrayList erreurs) {
    this.erreurs = erreurs;
  }
  /**
   * @return Returns the hActionListe.
   */
  public Hashtable getHActionListe() {
    return hActionListe;
  }
  /**
   * @param actionListe The hActionListe to set.
   */
  public void setHActionListe(Hashtable actionListe) {
    hActionListe = actionListe;
  }
  /**
   * @return Returns the hActionPanier.
   */
  public Hashtable getHActionPanier() {
    return hActionPanier;
  }
  /**
   * @param actionPanier The hActionPanier to set.
   */
  public void setHActionPanier(Hashtable actionPanier) {
    hActionPanier = actionPanier;
  }
  /**
   * @return Returns the hActionValidationPanier.
   */
  public Hashtable getHActionValidationPanier() {
    return hActionValidationPanier;
  }
  /**
   * @param actionValidationPanier The hActionValidationPanier to set.
   */
  public void setHActionValidationPanier(Hashtable actionValidationPanier) {
    hActionValidationPanier = actionValidationPanier;
  }

  public void init() throws ServletException{
    // init classe parent
    super.init();
    // on rcupre les paramtres d'initialisation de la servlet
    config = getServletConfig();
    String param = null;
    for (int i = 0; i < parameters.length; i++) {
      param = config.getInitParameter(parameters[i]);
      if (param == null) {
        // on mmorise l'erreur
        erreurs.add("Paramtre [" + parameters[i]
            + "] absent dans le fichier [web.xml]");
      }
    }
    // des erreurs ?
    if (erreurs.size() != 0) {
      return;
    }
    // on cre un objet IArticlesDomain d'accs  la couche mtier
    try {
      articlesDomain = (IArticlesDomain) (new XmlBeanFactory(
          new ClassPathResource((String) config
              .getInitParameter(SPRING_CONFIG_FILENAME))))
          .getBean("articlesDomain");
    } catch (Exception ex) {
      // on mmorise l'erreur
      erreurs.add("Erreur de configuration de l'accs aux donnes : "
          + ex.toString());
      return;
    }
    // on mmorise certaines url de l'application
    hActionListe.put("href", ACTION_LISTE);
    hActionListe.put("lien", lienActionListe);
    hActionPanier.put("href", ACTION_PANIER);
    hActionPanier.put("lien", lienActionPanier);
    hActionValidationPanier.put("href", ACTION_VALIDATION_PANIER);
    hActionValidationPanier.put("lien", lienActionValidationPanier);

    // c'est fini
    return;
  }

}